void astroloop() {

  bool active = false;
  unsigned long MicrosSinceAstroStart = micros();
  static unsigned long FirstStepTime = 0;
  unsigned long currentStep = 0;
  int stepImpulsLength = 300; //length of STEP-impuls in [micros]

  unsigned long AstroExpo01timeinterval = AstroExpoTime01 + AstroExpo01delay + AstroExpoTime02 + AstroExpo02delay + AstroExpoTime03 + AstroExpo03delay;

//Serial.println("Hallo");


  while (startAstro == true) {
    static unsigned long previousMicrosAstro = 0;
    static unsigned long previousMicrosHDR1 = 0;
    static unsigned long previousMicrosHDR2 = 0;
    static unsigned long previousMicrosHDR3 = 0;
    unsigned long currentMicrosAstro = micros();

 


    //Set motor-step HIGH
    if (currentMicrosAstro  - previousMicrosAstro >= AstroUpdateInterval ) {
      digitalWrite(Xstep, HIGH);

      if (currentStep == 0) {
        FirstStepTime = micros();

      }
      currentStep++;
    }
    //Set motor-step LOW
    if (currentMicrosAstro  - previousMicrosAstro >= AstroUpdateInterval + stepImpulsLength) {
      digitalWrite(Xstep, LOW);

      previousMicrosAstro = currentMicrosAstro - stepImpulsLength;
    }


    //------------------------------------------------------

    if (AstroPicCurrentRepeat == 0) {
      currentMicrosAstro = micros();
      unsigned long delayTime = currentMicrosAstro - FirstStepTime;

      if (delayTime > AstroStartDelay * 1000000 && active == false) {
        Serial.println(currentMicrosAstro - FirstStepTime);
       digitalWrite(dslrTrigger, HIGH);
        active = true;
      }

      if (currentMicrosAstro - previousMicrosHDR1 >= AstroExpoTime01 * 1000000 + AstroStartDelay * 1000000) {
        digitalWrite(dslrTrigger, LOW);
        active = false;
        AstroPicCurrentRepeat++;
        previousMicrosHDR1 = currentMicrosAstro;
      }


    }
    else {

      //Set motor-step LOW
      if (currentMicrosAstro  - previousMicrosHDR1 >= AstroExpoTime01 * 1000000 + AstroExpo01delay * 1000000) {
        digitalWrite(dslrTrigger, LOW);
        active = false;

        previousMicrosHDR1 = currentMicrosAstro;
      }

      //Set motor-step HIGH
      if (currentMicrosAstro  - previousMicrosHDR1 >= AstroExpo01delay * 1000000 && active == false) {
        digitalWrite(dslrTrigger, HIGH);
        AstroPicCurrentRepeat++;
        active = true;

      }



    }

  }
}
